ElevateOrder 方法 (ActiveX)
将样条曲线的顺序提升到给定顺序。 支持的平台:仅限 Windows 返回值 (RetVal)无返回值。 言论样条曲线的阶数等于样条曲线的阶数加一 (+1)。可以使用属性查询样条的度数。Degree 输入大于当前值的值会均匀地增加样条曲线上的控制点数,以实现更局部的控制。样条阶一旦提升,就不能减少。 当样条曲线被抬高时,该样条曲线将从插值(拟合)样条转换为控制点样条曲线。这意味着在高程之后,样条不再具有拟合切线,并且样条的 和 属性不再可用。编辑控制点样条曲线的唯一方法是通过属性或 or 方法。StartTangentEndTangentControlPointsSetControlPointGetControlPoint 例子VBA: Sub Example_ElevateOrder() ' This example creates a spline object in model space. ' It then elevates the order of the spline. ' Create the spline Dim splineObj As AcadSpline Dim startTan(0 To 2) As Double Dim endTan(0 To 2) As Double Dim fitPoints(0 To 8) As Double startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0 endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0 fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0 fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0 fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0 Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan) ZoomAll MsgBox "The current order of the spline is " & splineObj.Degree + 1, , "ElevateOrder Example" ' Elevate the order of the spline splineObj.ElevateOrder (splineObj.Degree + 10) ThisDrawing.Regen True MsgBox "The order of the spline has been raised to " & splineObj.Degree + 1, , "ElevateOrder Example" End Sub 可视化 LISP: (vl-load-com) (defun c:Example_ElevateOrder() ;; This example creates a spline object in model space. ;; It then elevates the order of the spline. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Create the spline (setq startTan (vlax-3d-point 0.5 0.5 0) endTan (vlax-3d-point 0.5 0.5 0) fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8))) (vlax-safearray-fill fitPoints '(1 1 0 5 5 0 10 0 0 ) ) ;; Create the spline (setq modelSpace (vla-get-ModelSpace doc)) (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan)) (vla-ZoomAll acadObj) (alert (strcat "The current order of the spline is " (itoa (1+ (vla-get-Degree splineObj))))) ;; Elevate the order of the spline (vla-ElevateOrder splineObj (+ (vla-get-Degree splineObj) 10)) (vla-Regen doc :vlax-true) (alert (strcat "The order of the spline has been raised to " (itoa (1+ (vla-get-Degree splineObj))))) ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2024-12-15 13:14
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.